#!/bin/sh

# File: e17-desktop-convert.sh
# by ^thehatsrule^ for testing with e17 on dsl
# to integrate xtdesktop's icon entries into the e17 menu

# To use, just execute this script
# To override existing files, use the -f option

INSTALL_DIR="${HOME}/.e/e/applications/menu/favorite/dsl-desktop"
if ! [ -e "${INSTALL_DIR}" ]; then
  printf "Creating ${INSTALL_DIR}...\n"
  mkdir -p "${INSTALL_DIR}"
fi
if ! [ -d "${INSTALL_DIR}" ]; then
  printf "Error on using ${INSTALL_DIR}\n"
  exit 1
fi

cd ~/.xtdesktop
IFS="
"

for eachlnk in `ls *.lnk`
do
  printf "Converting: ${eachlnk} "
  for eachline in `cat ${eachlnk} `
  do
    case "${eachline}" in
      *Type:* )
          _Type="Application"
          ;;
      *Caption:* )
      # the following assumes "  <section>: <description>"
      # if this does change, we can use other (heavier) methods
          _Name=`printf "${eachline}"|cut -d' ' -f 4- `
          ;;
      *Command:* )
          _Exec=`printf "${eachline}"|cut -d' ' -f 4- `
          ;;
      *Icon:* )
          _Icon=`printf "${eachline}"|cut -d' ' -f 4- `
          ;;
    esac
    printf "."

  done

  _fname="${INSTALL_DIR}/${_Name}.desktop"
  printf " "

  if [ "$1" = "-f" -o ! -e "${_fname}" ]; then
    printf "[Desktop Entry]\n" > ${_fname}
    printf "Type=${_Type}\n" >> ${_fname}
    printf "Exec=${_Exec}\n" >> ${_fname}
    printf "Name=${_Name}\n" >> ${_fname}
    printf "Icon=/home/dsl/${_Icon}\n" >> ${_fname}
    printf "${_Name}.desktop\n" 
  else
    printf "Skipping, ${_Name}.desktop already exists\n" 
  fi
  unset _Type _Name _Exec _Icon

done

